#include <stdio.h>
#include <dlfcn.h>

#include <dmx/plugin.h>


dmxplugin_t *p2 = NULL;


static int my_notify (dmxuniverse_t *u)
{
  if (u)
    {
      if (p2 && p2->send_universe)
      {
        dmxuniverse_t u1;
        u1.numslots = u->numslots;
        memcpy (u1.buffer, u->buffer, u1.numslots);

        if (p2->send_universe (0, &u1) < 0)
          printf ("send_universe failed\n");
      }
    }
  return 0;
}



int main(int argc, char **argv)
{
  dmxuniverse_t u1; /* input */
  dmxplugin_t *p1 = NULL;

  char *name1;
  char *name2;

  if (argc<3)
    {
      printf ("usage %s <plugin1> <plugin2>\n", argv[0]);
      exit(0);
    }

  name1 = argv[1];
  name2 = argv[2];

  p1 = loadPlugin (NULL, name1);
  if (!p1)
    {
      printf ("Error loading dmx-plugin %s: %s\n", name2, dlerror());
      exit(1);
    }

  if (strcmp(name1,name2)==0)
    p2 = p1;
  else
    {
      p2 = loadPlugin (NULL, name2);
      if (!p2)
        {
          p2->delete(p2);
          printf ("Error loading dmx-plugin %s: %s\n", name2, dlerror());
          exit(1);
        }
    }

  u1.plugin = NULL;
  u1.notify = my_notify;
  u1.delete = NULL;
  u1.numslots = 512;

  if (p1->bind_universe (0, &u1) >= 0)
    {
      char cmd[100];

      while (printf("> "), fflush(stdout), fgets (cmd, sizeof(cmd), stdin))
      {
      }

      p1->unbind_universe (0, &u1);
    }

  if (p2 && p1!=p2 && p2->delete) p2->delete (p2);
  if (p1->delete) p1->delete (p1);
  sleep(1);

  exit(0);
}

