/*
 *
 */


typedef struct s_dmxuniverse_t dmxuniverse_t;
typedef struct s_dmxplugin_info_t dmxplugin_info_t;
typedef struct s_dmxplugin_t dmxplugin_t;

struct s_dmxuniverse_t
{
  dmxplugin_t  *plugin;

  int (*notify) (dmxuniverse_t *u);
  int (*delete) (dmxuniverse_t *u);

  int           numslots;
  unsigned char buffer[512];
};



struct s_dmxplugin_info_t
{
  char   vendor_name[40];
  char   proto_name[40];
  float  proto_release;

  float  release;
  char   author[40];
  char   email[40];
  int    num_universes;
};

struct s_dmxplugin_t
{
  char *fullname;

  dmxuniverse_t (*createUniverse) (dmxplugin_t *p);
  int           (*delete)         (dmxplugin_t *p);


  int (*send_universe)   (int nr, dmxuniverse_t * u);
  int (*bind_universe)   (int nr, dmxuniverse_t *u);
  int (*unbind_universe) (int nr, dmxuniverse_t *u);
  int (*get_plugin_info) (dmxplugin_info_t *info);
  int (*initialize)      ();
  int (*finalize)        ();


  void *handle;
};



dmxplugin_t *loadPlugin (char *path, char *name);




