/*
 *
 *
 *
 */
#ifndef __avabudp_h__
#define __avabudp_h__


#define AVAB_UDP_MAGIC              0x1fe2
#define AVAB_UDP_TELEGRAM_TYPE      0x2000




#define AVAB_UDP_N_SUBNET              (10)                     /* number of AvabUDP subnets including the default subnet */
#define AVAB_UDP_DEFAULT_SUBNET        (0)                      /* this is the default sunbet */

#define AVAB_UDP_SUBNET_MIN            (0)                    /* first subnet id */
#define AVAB_UDP_SUBNET_MAX            (AVAB_UDP_N_SUBNET-1)  /* last subnet id */

#define AVAB_UDP_DEFAULT_PORT          (5080)                       /* portnumber for default subnet */
#define AVAB_UDP_SUBNET_PORT(i)        (((i)>=AVAB_UDP_SUBNET_MIN && (i)<=AVAB_UDP_SUBNET_MAX)?(AVAB_UDP_DEFAULT_PORT+(i)):-1) /* portnumber for a specific subnet */




#define AVAB_FRAME_OUTPUT_UNPACKED     22 /* unpacket data */

/* universe-id 1..32 */
#define AVAB_UDP_N_UNIV                32  /* number of universes per AvabUDP subnet */

#define AVAB_UDP_UNIV_MIN              1                /* first universe id */
#define AVAB_UDP_UNIV_MAX              AVAB_UDP_N_UNIV  /* last universe id */





typedef unsigned short seqnum_t;      /* sequence-number 0..0xffff */
typedef unsigned short subnet_t;      /* subnet-id 1..AVAB_UDP_LAST_SUBNET */
typedef unsigned short universe_t;    /* universe 1..9 or 0 */

typedef struct
{
  seqnum_t        sequence;      /* sequence number 0..0xffff */
  unsigned long   clock;         /* reserved for future use. set to 0 by sender, receiver must not check */
  unsigned short  unused;        /* reserved for future use. set to 0 by sender, receiver must not check */
  unsigned long   dirty_flag;    /* reserved for future use. set to 0 by sender, receiver must not check */
  unsigned long   date;          /* reserved for future use. set to 0 by sender, receiver must not check */
  unsigned short  frame_type;    /* = AVAB_FRAME_OUTPUT_UNPACKED */
  unsigned short  universe;      /* = AVAB_UDP_UNIV_MIN..AVAB_UDP_UNIV_MAX */
  unsigned char   values[512];   /* the dmx values */
} AvabUDPFrame_t;

typedef struct
{
  unsigned short  magic_number;   /* = AVAB_UDP_MAGIC */
  unsigned short  telegram_type;  /* = AVAB_UDP_TELEGRAM_TYPE */
  unsigned long   source_address; /* warning, not ipv6 compliant */
  unsigned short  frames_count;   /* number of dmx-frames transported with this datagram. Can be 1 or 2 */
  AvabUDPFrame_t  frames[2];      /* the dmx-frames */
} __attribute__((packed)) AvabUDPDatagram_t;


#endif
